/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 * タスクをJTableで使うためのモデル
 * @author tondol
 */
public class TaskTableModel extends AbstractTableModel {
    Vector<TaskAbstract> items = null;
    
    public TaskTableModel() {
        super();
        items = new Vector<TaskAbstract>();
    }
    
    /**
     * データ操作用
     */
    public TaskAbstract getItem(int index) {
        return items.get(index);
    }
    
    public void addItem(TaskAbstract task) {
        items.add(task);
        int index = items.indexOf(task);
        fireTableRowsInserted(index, index);
    }
    
    public void deleteItem(TaskAbstract task) {
        int index = items.indexOf(task);
        items.remove(task);
        fireTableRowsDeleted(index, index);
    }
    
    public void updateItem(TaskAbstract task) {
        int index = items.indexOf(task);
        fireTableRowsUpdated(index, index);
    }
    
    /**
     * 表のインターフェイス
     */
    @Override public int getRowCount() {
        return items.size();
    }

    @Override public int getColumnCount() {
        return 3;
    }

    @Override public String getColumnName(int column) {
        String values[] = { "ファイル名", "種類", "状態" };
        return values[column];
    }

    @Override public Object getValueAt(int rowIndex, int columnIndex) {
        if (rowIndex >= getRowCount()) return null;
        switch (columnIndex) {
            case 0: return getItem(rowIndex).getName();
            case 1: return getItem(rowIndex).getType();
            case 2: return getItem(rowIndex).getStatus();
            default: return null;
        }
    }
}
